GameConfig = class2("GameConfig");

function GameConfig:ctor()
    --大小写字母正则 "ui\$([a-z].*.[A-Z]+[a-z].*.).u"
    self.resVersion = nil;
    self.sdkId = 0;
    self.isShenhe = false;--是否审核版本
    self.checkVerUrl = "https://dmbzwsfz.geiniwan.com/check_ver.php?sh_ver=%s&sdkid=%s&type=%s"..math.random();
    -- self.checkVerUrl = "http://192.168.10.167:9981/check_ver.php?sh_ver=%s&sdkid=%s&type=%s&"..math.random();
    self.configUrl = "";--登录机 后台域名
    self.delList = nil;--删除配置
    self.urlList = nil;--cdn路径配置
    self.versionList = nil;--更新版本文件

    -- self.verUrl = "http://192.168.10.10:5001/";
    -- self.verUrl = "https://mlloginsgzm.geiniwan.com/urlConfig/";
    self.downUrls = nil;--更新内容下载地址[从checkVerUrl读取]
    self.isDownload = true;--是否使用资源包
    self.showFPS = false;--是否显示帧频
    self.showDebug = false;--显示调试信息(开启记录tick耗时,socket耗时)
    self.showPrint = false;--是否显示print
    self.showTestBtns = false;--是否默认显示调试按钮
    self.agentId = 0;--代理ID
    self.bigVersion = nil;--大包版本
    self.shenHeBigVersion = nil;--审核包版本
    self.plusList = nil;--增量包
    self.dvVersion = 1;--mini包dv版本号(默认=1,审核不更新，默认1)
    self.downloadUrl = "";--资源包下载地址[从checkVerUrl读取]
    self.downloadUrlSec = "";--小包资源备用下载地址[从checkVerUrl读取]
    self.errorUrl = "https://gamebzwsfz.geiniwan.com";--分后台报错信息上报地址

    self.rechargeSignUrl = "https://loginbzwsfz.geiniwan.com/game/api/sign_3k.php"; --充值获取签名接口

    self.isOpenIOSSh = false;--是否开启ios审核 false/true

    self.stopPreDownload = false;--暂停预加载下载
    self.stopAllDownload = false;--全停止下载
    self.isHasUpdate = false;--是否存在更新文件
    self.codeVersion = 0;--代码版本号
    
    -- windows平台显示调试信息
    if self:isWin() then
        self.showFPS = true;
        self.showPrint = true;
    end

    if self.resVersion == nil then
        self.resVersion = 129;
    end
end

-- 开关预加载
function GameConfig:setStopPreDownload()
    self.stopPreDownload = not self.stopPreDownload;
end

-- 开关 下载
function GameConfig:setStopAllDownload()
    self.stopAllDownload = not self.stopAllDownload;
end

-- 开关显示FPS
function GameConfig:setShowFPS()
    self.showFPS = not self.showFPS;
end

-- 开关print输出
function GameConfig:setShowPrint()
    self.showPrint = not self.showPrint;
end

-- 开关tick性能耗时
function GameConfig:setShowDebug()
    self.showDebug = not self.showDebug;
end

function GameConfig:setAgentId(agentId,force)
    -- 等于0 才赋值，否则上面定义的，方便运营佬改
    if self.agentId == 0 or force == true then
        self.agentId = agentId;
    end
end

function GameConfig:getCheckVerUrl()
    local t;
    if self:isIOS() == true then
        t = 1;
    else
        t = 2;
    end
    return string.format(self.checkVerUrl, self.bigVersion, self.sdkId, t);
end

function GameConfig:needUpdate()
    -- do return true;end;
    if self:isAndroid() == false and self:isIOS() == false then return false; end
    if self.isShenhe == true then return false; end
    return self.sdkId > 0;
end

function GameConfig:needAdditionUpdate()
    return false;
end

function GameConfig:isNoSdkOrTestSdk()
    return self.sdkId == 0 or self.sdkId == 99999999 or self.sdkId == 88888888;
end

function GameConfig:isTestServer()
    return self.sdkId == 0 or self.sdkId == 99999999;
end

--是否是ios审核
function GameConfig:isIOSShenhe()
    -- return true;
    return (self:isIOS() and self.isShenhe) or self.isOpenIOSSh;
end

function GameConfig:isWin()
    return not self:isAndroid() and not self:isIOS();
end

function GameConfig:isAndroid()
    -- do return true;end;
    return UnityEngine.Application.platform == UnityEngine.RuntimePlatform.Android;
end

function GameConfig:isIOS()
    return UnityEngine.Application.platform == UnityEngine.RuntimePlatform.IPhonePlayer;
end

function GameConfig:getErrorLogUrl()
    return self.errorUrl.."/api/client_error_api.php?" .. math.random();
end
